/*
 * Copyright (c) 2004 MUSIC TECHNOLOGY GROUP (MTG)
 *                         UNIVERSITAT POMPEU FABRA
 *
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */

namespace CLAM {

/** Auxiliary class to define the order of a moment at compile time*/
template<int order> struct O
{
	public: static O<order> instance;
};

template<int order> O<order>  O<order>::instance;

//A nicer way of referring to the first orders

extern O<1>* FirstOrder;
extern O<2>* SecondOrder;
extern O<3>* ThirdOrder;
extern O<4>* FourthOrder;
extern O<5>* FifthOrder;

} // namespace CLAM


